008集—— Keyword关键字及getstring的用法(CAD—C#二次开发入门)

CAD二开中,经常会用到用户交互功能,常见的方法如下:

GetKeyword 方法提示用户在 AutoCAD 命令提示下输入关键字,GetString 方法提示用户在 AutoCAD 命令提示下输入字符串。两者就有区别又有相似处,getkeyword只允许用户输入指定的字符。

GetKeyword 方法:AllowNone 属性为False强制用户输入关键字,而禁止输入 NULL(按回车键)。Keywords 用于添加有效的关键字列表。

GetString 方法:该方法接收两个参数。PromptStringOptions 对象允许控制用户输入以及怎样显示提示信息。PromptStringOptions 对象的 AllowSpaces 属性控制是否允许输入空格。如果为 False ,按空格键将中止用户输入。

getkeyword案例如下:

附代码:

cs 复制代码
using AcTools;
using Autodesk.AutoCAD.ApplicationServices;
using Autodesk.AutoCAD.DatabaseServices;
using Autodesk.AutoCAD.EditorInput;
using Autodesk.AutoCAD.Geometry;
using Autodesk.AutoCAD.Runtime;
using System;
using System.Collections.Generic;
using System.Linq;

namespace Acdemo
{
    public  class Acdemo
    {

        [CommandMethod("xx")]
        public void ACDE()
        {
            Document acDoc = Application.DocumentManager.MdiActiveDocument;
            Database db = HostApplicationServices.WorkingDatabase;
            Line line = new Line(Point3d.Origin, new Point3d(100, 100, 0));
            Line line1 = new Line(Point3d.Origin, new Point3d(50, 200, 0));
            //db.AddEntityToModeSpace(line);
            PromptKeywordOptions pKeyOpts = new PromptKeywordOptions("");
            pKeyOpts.Message = "\nEnter an option ";
            pKeyOpts.Keywords.Add("Line");
            pKeyOpts.Keywords.Add("Circle");
            pKeyOpts.Keywords.Add("Arc");
            pKeyOpts.AllowNone = false;

            PromptResult pKeyRes = acDoc.Editor.GetKeywords(pKeyOpts);

            //Application.ShowAlertDialog("Entered keyword: " +
            //                            pKeyRes.StringResult);
            //if (pKeyRes.StringResult == "Line")
            //{
            //    db.AddLineToModeSpace(new Point3d(), new Point3d(100, 100, 0));

            //}
            switch (pKeyRes.StringResult)
            {
                case "Line":
                    Database db1 = HostApplicationServices.WorkingDatabase;
                    db1.AddEntityToModeSpace(line1);
                    break;
                case "Circle":
                    db.AddCircleModeSpace(new Point3d(), 100);
                    break;
                case "Arc":
                    db.AddArcToModeSpace(new Point3d(0,0,0), new Point3d(500, 100, 0), new Point3d(200, 200, 0));
                    break;

            }

        }
    }
}

getstring用法:

cs 复制代码
using AcTools;
using Autodesk.AutoCAD.ApplicationServices;
using Autodesk.AutoCAD.DatabaseServices;
using Autodesk.AutoCAD.EditorInput;
using Autodesk.AutoCAD.Geometry;
using Autodesk.AutoCAD.Runtime;
using System;
using System.Collections.Generic;
using System.Linq;

namespace Acdemo
{
    public  class Acdemo
    {
        public static void GetStringFromUser(string message)
        {
            Document acDoc = Application.DocumentManager.MdiActiveDocument;

            PromptStringOptions pStrOpts = new PromptStringOptions("\nEnter your name: ");
            pStrOpts.AllowSpaces = true;
            PromptResult pStrRes = acDoc.Editor.GetString(pStrOpts);

            Application.ShowAlertDialog(message +  "\nThe name entered was: " +
                                        pStrRes.StringResult);
        }

        [CommandMethod("xx")]
        public void ACDE()
        {  
            GetStringFromUser("Hello,world !");
        }
    }
}
相关推荐
IT猿手3 分钟前
最新高性能多目标优化算法:多目标麋鹿优化算法(MOEHO)求解TP1-TP10及工程应用---盘式制动器设计,提供完整MATLAB代码
开发语言·深度学习·算法·机器学习·matlab·多目标算法
m0_748236584 分钟前
《Web 应用项目开发:从构思到上线的全过程》
服务器·前端·数据库
苏三说技术6 分钟前
Redis 性能优化的18招
数据库·redis·性能优化
单片机学习之路8 分钟前
【C语言】结构
c语言·开发语言·stm32·单片机·51单片机
蜗牛hb17 分钟前
VMware Workstation虚拟机网络模式
开发语言·学习·php
Tttian62230 分钟前
基于Pycharm与数据库的新闻管理系统(2)Redis
数据库·redis·pycharm
汤姆和杰瑞在瑞士吃糯米粑粑32 分钟前
【C++学习篇】AVL树
开发语言·c++·学习
Biomamba生信基地40 分钟前
R语言基础| 功效分析
开发语言·python·r语言·医药
手可摘星河42 分钟前
php中 cli和cgi的区别
开发语言·php
CT随1 小时前
Redis内存碎片详解
java·开发语言